<?php

/**
 * @package CRM
 * @copyright CiviCRM LLC https://civicrm.org/licensing
 *
 * Generated from eventics/xml/schema/CRM/Eventics/Eventics.xml
 * DO NOT EDIT.  Generated by CRM_Core_CodeGen
 * (GenCodeChecksum:4f05971eb425d27e4bb920c4be86b769)
 */
use CRM_Eventics_ExtensionUtil as E;

/**
 * Database access object for the Eventics entity.
 */
class CRM_Eventics_DAO_Eventics extends CRM_Core_DAO {
  const EXT = E::LONG_NAME;
  const TABLE_ADDED = '';

  /**
   * Static instance to hold the table name.
   *
   * @var string
   */
  public static $_tableName = 'civicrm_eventics';

  /**
   * Should CiviCRM log any modifications to this table in the civicrm_log table.
   *
   * @var bool
   */
  public static $_log = TRUE;

  /**
   * PK
   *
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $id;

  /**
   * FK to Event
   *
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $event_id;

  /**
   * Should the ics file be sent for this event?
   *
   * @var bool|string|null
   *   (SQL type: tinyint)
   *   Note that values will be retrieved from the database as a string.
   */
  public $ics_enabled;

  /**
   * The URL or physical location of the event
   *
   * @var string|null
   *   (SQL type: text)
   *   Note that values will be retrieved from the database as a string.
   */
  public $event_location;

  /**
   * Details about the event
   *
   * @var string|null
   *   (SQL type: text)
   *   Note that values will be retrieved from the database as a string.
   */
  public $event_description;

  /**
   * Override the event timezone
   *
   * @var string|null
   *   (SQL type: text)
   *   Note that values will be retrieved from the database as a string.
   */
  public $event_timezone;

  /**
   * Class constructor.
   */
  public function __construct() {
    $this->__table = 'civicrm_eventics';
    parent::__construct();
  }

  /**
   * Returns localized title of this entity.
   *
   * @param bool $plural
   *   Whether to return the plural version of the title.
   */
  public static function getEntityTitle($plural = FALSE) {
    return $plural ? E::ts('Eventicses') : E::ts('Eventics');
  }

  /**
   * Returns foreign keys and entity references.
   *
   * @return array
   *   [CRM_Core_Reference_Interface]
   */
  public static function getReferenceColumns() {
    if (!isset(Civi::$statics[__CLASS__]['links'])) {
      Civi::$statics[__CLASS__]['links'] = static::createReferenceColumns(__CLASS__);
      Civi::$statics[__CLASS__]['links'][] = new CRM_Core_Reference_Basic(self::getTableName(), 'event_id', 'civicrm_event', 'id');
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'links_callback', Civi::$statics[__CLASS__]['links']);
    }
    return Civi::$statics[__CLASS__]['links'];
  }

  /**
   * Returns all the column names of this table
   *
   * @return array
   */
  public static function &fields() {
    if (!isset(Civi::$statics[__CLASS__]['fields'])) {
      Civi::$statics[__CLASS__]['fields'] = [
        'id' => [
          'name' => 'id',
          'type' => CRM_Utils_Type::T_INT,
          'description' => E::ts('PK'),
          'where' => 'civicrm_eventics.id',
          'table_name' => 'civicrm_eventics',
          'entity' => 'Eventics',
          'bao' => 'CRM_Eventics_DAO_Eventics',
          'localizable' => 0,
          'readonly' => TRUE,
          'add' => NULL,
        ],
        'event_id' => [
          'name' => 'event_id',
          'type' => CRM_Utils_Type::T_INT,
          'description' => E::ts('FK to Event'),
          'where' => 'civicrm_eventics.event_id',
          'table_name' => 'civicrm_eventics',
          'entity' => 'Eventics',
          'bao' => 'CRM_Eventics_DAO_Eventics',
          'localizable' => 0,
          'FKClassName' => 'CRM_Event_DAO_Event',
          'add' => NULL,
        ],
        'ics_enabled' => [
          'name' => 'ics_enabled',
          'type' => CRM_Utils_Type::T_BOOLEAN,
          'title' => E::ts('Ics Enabled'),
          'description' => E::ts('Should the ics file be sent for this event?'),
          'where' => 'civicrm_eventics.ics_enabled',
          'table_name' => 'civicrm_eventics',
          'entity' => 'Eventics',
          'bao' => 'CRM_Eventics_DAO_Eventics',
          'localizable' => 0,
          'add' => NULL,
        ],
        'event_location' => [
          'name' => 'event_location',
          'type' => CRM_Utils_Type::T_TEXT,
          'title' => E::ts('Event Location'),
          'description' => E::ts('The URL or physical location of the event'),
          'where' => 'civicrm_eventics.event_location',
          'table_name' => 'civicrm_eventics',
          'entity' => 'Eventics',
          'bao' => 'CRM_Eventics_DAO_Eventics',
          'localizable' => 0,
          'add' => NULL,
        ],
        'event_description' => [
          'name' => 'event_description',
          'type' => CRM_Utils_Type::T_TEXT,
          'title' => E::ts('Event Description'),
          'description' => E::ts('Details about the event'),
          'where' => 'civicrm_eventics.event_description',
          'table_name' => 'civicrm_eventics',
          'entity' => 'Eventics',
          'bao' => 'CRM_Eventics_DAO_Eventics',
          'localizable' => 0,
          'add' => NULL,
        ],
        'event_timezone' => [
          'name' => 'event_timezone',
          'type' => CRM_Utils_Type::T_TEXT,
          'title' => E::ts('Event Timezone'),
          'description' => E::ts('Override the event timezone'),
          'where' => 'civicrm_eventics.event_timezone',
          'table_name' => 'civicrm_eventics',
          'entity' => 'Eventics',
          'bao' => 'CRM_Eventics_DAO_Eventics',
          'localizable' => 0,
          'add' => NULL,
        ],
      ];
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'fields_callback', Civi::$statics[__CLASS__]['fields']);
    }
    return Civi::$statics[__CLASS__]['fields'];
  }

  /**
   * Return a mapping from field-name to the corresponding key (as used in fields()).
   *
   * @return array
   *   Array(string $name => string $uniqueName).
   */
  public static function &fieldKeys() {
    if (!isset(Civi::$statics[__CLASS__]['fieldKeys'])) {
      Civi::$statics[__CLASS__]['fieldKeys'] = array_flip(CRM_Utils_Array::collect('name', self::fields()));
    }
    return Civi::$statics[__CLASS__]['fieldKeys'];
  }

  /**
   * Returns the names of this table
   *
   * @return string
   */
  public static function getTableName() {
    return self::$_tableName;
  }

  /**
   * Returns if this table needs to be logged
   *
   * @return bool
   */
  public function getLog() {
    return self::$_log;
  }

  /**
   * Returns the list of fields that can be imported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &import($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getImports(__CLASS__, 'eventics', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of fields that can be exported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &export($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getExports(__CLASS__, 'eventics', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of indices
   *
   * @param bool $localize
   *
   * @return array
   */
  public static function indices($localize = TRUE) {
    $indices = [];
    return ($localize && !empty($indices)) ? CRM_Core_DAO_AllCoreTables::multilingualize(__CLASS__, $indices) : $indices;
  }

}
