<?php

use CRM_Eventics_ExtensionUtil as E;

/**
 * Collection of upgrade steps.
 */
class CRM_Eventics_Upgrader extends CRM_Extension_Upgrader_Base {

  // By convention, functions that look like "function upgrade_NNNN()" are
  // upgrade tasks. They are executed in order (like Drupal's hook_update_N).

  // public function install() {
  // }

  // public function postInstall() {
  // }

  // public function uninstall() {
  // }

  // public function enable() {
  // }

  // public function disable() {
  // }

  /**
   * Create the eventics SQL table.
   *
   * @return TRUE on success
   * @throws Exception
   */
  public function upgrade_1001() {
    $this->ctx->log->info('Applying update 1001');
    if (!CRM_Core_DAO::checkTableExists('civicrm_eventics')) {
      CRM_Core_DAO::executeQuery("
        CREATE TABLE `civicrm_eventics` (
         `id` int unsigned  AUTO_INCREMENT  COMMENT 'PK',
         `event_id` int unsigned COMMENT 'FK to Event',
         `ics_enabled` tinyint COMMENT 'Should the ics file be sent for this event?',
         `event_location` text COMMENT 'The URL or physical location of the event',
         `event_description` text COMMENT 'Details about the event',
         PRIMARY KEY (`id`),
         CONSTRAINT FK_civicrm_eventics_event_id FOREIGN KEY (`event_id`) REFERENCES `civicrm_event`(`id`) ON DELETE CASCADE
       ) ENGINE=InnoDB", NULL, TRUE, NULL, FALSE, FALSE);
    }
    return TRUE;
  }

  /**
   * Add the event_timezone field.
   *
   * @return TRUE on success
   * @throws Exception
   */
  public function upgrade_1002() {
    $this->ctx->log->info('Applying update 1002');
    if (!CRM_Core_BAO_SchemaHandler::checkIfFieldExists('civicrm_eventics', 'event_timezone')) {
      CRM_Core_DAO::executeQuery("ALTER TABLE civicrm_eventics ADD COLUMN `event_timezone` text COMMENT 'Override the event timezone'");
    }
    return TRUE;
  }

}
