<?php

use CRM_Eventics_ExtensionUtil as E;

if (!Civi::settings()->get('eventics_optout')) {
  return [];
}

return [
  [
    'name' => 'CustomGroup_EventICS_Preferences',
    'entity' => 'CustomGroup',
    'cleanup' => 'unused',
    'update' => 'unmodified',
    'params' => [
      'version' => 4,
      'values' => [
        'name' => 'EventICS_Preferences',
        'title' => E::ts('EventICS Preferences'),
        'style' => 'Inline',
        'weight' => 21,
        'collapse_adv_display' => TRUE,
        'icon' => '',
      ],
      'match' => [
        'name',
      ],
    ],
  ],
  [
    'name' => 'CustomField_Opt_out',
    'entity' => 'CustomField',
    'cleanup' => 'unused',
    'update' => 'unmodified',
    'params' => [
      'version' => 4,
      'values' => [
        'custom_group_id.name' => 'EventICS_Preferences',
        'name' => 'Opt_out',
        'label' => E::ts('Opt-out'),
        'data_type' => 'Boolean',
        'html_type' => 'Radio',
        'help_pre' => E::ts('For this contact, do not attach iCal (ics) files to event confirmation emails.'),
        'options_per_line' => 1,
        'text_length' => 255,
        'note_columns' => 60,
        'note_rows' => 4,
        'column_name' => 'ics_opt_out',
      ],
      'match' => [
        'name',
      ],
    ],
  ],
];
