<?php

use CRM_Eventics_ExtensionUtil as E;

return [ 
  'eventics_default_send_ics' => [
    'name' => 'eventics_default_send_ics',
    'type' => 'Boolean',
    'default' => TRUE,
    'html_type' => 'checkbox',
    'title' => E::ts('Send iCal attachments for event registrations by default'),
    'is_domain' => 1,
    'is_contact' => 0,
    'description' => E::ts('Can be set per event as well.'),
    'settings_pages' => [
      'eventics' => [
        'weight' => 5,
      ]
    ],
  ],
  'eventics_send_google_link' => [
    'name' => 'eventics_send_google_link',
    'type' => 'Boolean',
    'default' => FALSE,
    'html_type' => 'checkbox',
    'title' => E::ts('Include a Google Calendar Link for event registrations'),
    'is_domain' => 1,
    'is_contact' => 0,
    'description' => E::ts('Provides a special Google Calendar Link for easier addition of events to Google calendars.') . ' ' . E::ts('Requires extra markup to be added to the message templates. <a %1>See the documentation for more information.</a>.', [1 => 'target="_blank" href="https://lab.civicrm.org/extensions/eventics/-/blob/master/README.md#adding-google--outlook-buttons-to-registration-confirmation"']),
    'settings_pages' => [
      'eventics' => [
        'weight' => 6,
      ]
    ],
  ],
  'eventics_send_outlook_link' => [
    'name' => 'eventics_send_outlook_link',
    'type' => 'Boolean',
    'default' => FALSE,
    'html_type' => 'checkbox',
    'title' => E::ts('Include a Outlook Calendar Link for event registrations'),
    'is_domain' => 1,
    'is_contact' => 0,
    'description' => E::ts('Provides a special Outlook Calendar Link for easier addition of events to Outlook calendars.') . ' ' . E::ts('Requires extra markup to be added to the message templates. <a %1>See the documentation for more information.</a>.', [1 => 'target="_blank" href="https://lab.civicrm.org/extensions/eventics/-/blob/master/README.md#adding-google--outlook-buttons-to-registration-confirmation"']),
    'settings_pages' => [
      'eventics' => [
        'weight' => 7,
      ]
    ],
  ],
  'eventics_optout' => [
    'name' => 'eventics_optout',
    'type' => 'Boolean',
    'default' => FALSE,
    'html_type' => 'checkbox',
    'title' => E::ts('Enable opt-out field'),
    'is_domain' => 1,
    'is_contact' => 0,
    'description' => E::ts('When enabled, creates a custom field so that people can opt-out of ICS attachments. Once enabled, you will be able to add this custom field to your communication preferences forms. The custom field is a managed entity. It will be automatically deleted if this setting is turned off (if not, flush the CiviCRM cache), or if this extension is uninstalled.'),
    'settings_pages' => [
      'eventics' => [
        'weight' => 90,
      ]
    ],
    'post_change' => [
      'CRM_Eventics_Utils_Helper::onChangeOptoutSetting',
    ],
  ],
];
